blob: b3be439216ee904614bde6ed329450c2dfa2d7b1 [file] [log] [blame]
Chris Masone2aa55332011-12-30 14:41:07 -08001#!/bin/bash
2#
3# Copyright (c) 2012 The Chromium OS Authors. All rights reserved.
4# Use of this source code is governed by a BSD-style license that can be
5# found in the LICENSE file.
6
7USAGE="Usage: setup_dev_autotest.sh [-p <password>] [-a </path/to/autotest>]"
8HELP="${USAGE}\n\n\
9Install and configure software needed to run autotest locally.\n\
10If you're just working on tests, you do not need to run this.\n\n\
11Options:\n\
12 -p Desired Autotest DB password\n\
13 -a Absolute path to autotest source tree.\n"
14
15AUTOTEST_DIR=
16PASSWD=
17while getopts ":p:a:h" opt; do
18 case $opt in
19 a)
20 AUTOTEST_DIR=$OPTARG
21 ;;
22 p)
23 PASSWD=$OPTARG
24 ;;
25 h)
26 echo -e "${HELP}" >&2
27 exit 0
28 ;;
29 \?)
30 echo "Invalid option: -$OPTARG" >&2
31 echo "${USAGE}" >&2
32 exit 1
33 ;;
34 :)
35 echo "Option -$OPTARG requires an argument." >&2
36 echo "${USAGE}" >&2
37 exit 1
38 ;;
39 esac
40done
41
42if [ -z ${PASSWD} ]; then
43 read -s -p "Autotest DB password: " PASSWD
44 echo
45 if [ -z ${PASSWD} ]; then
46 echo "Empty passwords not allowed." >&2
47 exit 1
48 fi
49 read -s -p "Re-enter password: " PASSWD2
50 echo
51 if [ ${PASSWD} != ${PASSWD2} ]; then
52 echo "Passwords don't match." >&2
53 exit 1
54 fi
55fi
56
57if [ -z "${AUTOTEST_DIR}" ]; then
58 CANDIDATE=$(dirname "$(readlink -f "$0")" | egrep -o '(/[^/]+)*/files')
59 read -p "Enter autotest dir [${CANDIDATE}]: " AUTOTEST_DIR
60 if [ -z "${AUTOTEST_DIR}" ]; then
61 AUTOTEST_DIR="${CANDIDATE}"
62 fi
63fi
64
65SHADOW_CONFIG_PATH="${AUTOTEST_DIR}/shadow_config.ini"
66echo "Autotest supports local overrides of global configuration through a "
67echo "'shadow' configuration file. Setting one up for you now."
68if [ -f ${SHADOW_CONFIG_PATH} ]; then
69 clobber=
70 while read -n 1 -p "Clobber existing shadow config? [Y/n]: " clobber; do
71 echo
72 if [[ -z ${clobber} || $(echo ${clobber} | egrep -qi 'y|n') -eq 0 ]]; then
73 break
74 fi
75 echo "Please enter y or n."
76 done
77 if [[ ${clobber} = 'n' || ${clobber} = 'N' ]]; then
78 echo "Refusing to clobber existing shadow_config.ini."
79 exit 0
80 fi
81 echo "Clobbering existing shadow_config.ini."
82fi
83
84cat > "${SHADOW_CONFIG_PATH}" <<EOF
85[AUTOTEST_WEB]
86host: localhost
87password: ${PASSWD}
Chris Masonee61dd812012-01-10 18:04:21 -080088readonly_host: localhost
89readonly_user: chromeosqa-admin
90readonly_password: ${PASSWD}
Chris Masone2aa55332011-12-30 14:41:07 -080091
92[SERVER]
93hostname: localhost
Chris Sosae4181242012-09-10 16:54:30 -070094
95[SCHEDULER]
96drones: localhost
Chris Masone2aa55332011-12-30 14:41:07 -080097EOF
98echo -e "Done!\n"
99
100echo "Installing needed Ubuntu packages..."
101PKG_LIST="mysql-server mysql-common libapache2-mod-python python-mysqldb \
102gnuplot apache2-mpm-prefork unzip python-imaging libpng12-dev libfreetype6-dev \
103sqlite3 python-pysqlite2 git-core pbzip2 openjdk-6-jre openjdk-6-jdk \
Simran Basi3d182082012-09-07 10:15:25 -0700104python-crypto python-dev subversion build-essential python-setuptools \
105python-numpy python-scipy"
Chris Masone2aa55332011-12-30 14:41:07 -0800106
107if ! sudo apt-get install -y ${PKG_LIST}; then
108 echo "Could not install packages: $?"
109 exit 1
110fi
111echo -e "Done!\n"
112
Alex Millerda3ecf42012-07-25 11:51:13 -0700113echo "Setting up Database: chromeos_autotest_db in MySQL..."
Chris Masone2aa55332011-12-30 14:41:07 -0800114if mysql -u root -e ';' 2> /dev/null ; then
115 PASSWD_STRING=
116elif mysql -u root -p"${PASSWD}" -e ';' 2> /dev/null ; then
117 PASSWD_STRING="-p${PASSWD}"
118else
119 PASSWD_STRING="-p"
120fi
121
Alex Millerda3ecf42012-07-25 11:51:13 -0700122CLOBBERDB=
123EXISTING_DATABASE=$(mysql -u root "${PASSWD_STRING}" -e "SELECT SCHEMA_NAME \
124FROM INFORMATION_SCHEMA.SCHEMATA WHERE SCHEMA_NAME = 'chromeos_autotest_db'")
125if [ -n "${EXISTING_DATABASE}" ]; then
126 while read -n 1 -p "Clobber existing MySQL database? [y/N]: " CLOBBERDB; do
127 echo
128 if [[ -z ${CLOBBERDB} || $(echo ${CLOBBERDB} | egrep -qi 'y|n') -eq 0 ]];
129 then
130 break
131 fi
132 echo "Please enter y or n."
133 done
134else
135 CLOBBERDB='y'
136fi
137
138SQL_COMMAND="drop database if exists chromeos_autotest_db; \
139create database chromeos_autotest_db; \
140grant all privileges on chromeos_autotest_db.* TO \
Simran Basi3d182082012-09-07 10:15:25 -0700141'chromeosqa-admin'@'localhost' identified by '${PASSWD}'; \
Alex Millerda3ecf42012-07-25 11:51:13 -0700142FLUSH PRIVILEGES;"
143
Chris Masone2aa55332011-12-30 14:41:07 -0800144set -e
145
Alex Millerda3ecf42012-07-25 11:51:13 -0700146if [[ "${CLOBBERDB}" = 'y' || "${CLOBBERDB}" = 'Y' ]]; then
147 mysql -u root "${PASSWD_STRING}" -e "${SQL_COMMAND}"
148fi
Chris Masone2aa55332011-12-30 14:41:07 -0800149echo -e "Done!\n"
150
151AT_DIR=/usr/local/autotest
152echo -n "Bind-mounting your autotest dir at ${AT_DIR}..."
153sudo mkdir -p "${AT_DIR}"
154sudo mount --bind "${AUTOTEST_DIR}" "${AT_DIR}"
155echo -e "Done!\n"
156
157EXISTING_MOUNT=$(egrep "/.+[[:space:]]${AT_DIR}" /etc/fstab || /bin/true)
158if [ -n "${EXISTING_MOUNT}" ]; then
159 echo "${EXISTING_MOUNT}" | awk '{print $1 " already automounting at " $2}'
160 echo "We won't update /etc/fstab, but you should have a line line this:"
161 echo -e "${AUTOTEST_DIR}\t${AT_DIR}\tbind defaults,bind\t0\t0"
162else
163 echo -n "Adding aforementioned bind-mount to /etc/fstab..."
164 # Is there a better way to elevate privs and do a redirect?
165 sudo su -c \
166 "echo -e '${AUTOTEST_DIR}\t${AT_DIR}\tbind defaults,bind\t0\t0' \
167 >> /etc/fstab"
168 echo -e "Done!\n"
169fi
170
171echo -n "Reticulating splines..."
172"${AT_DIR}"/utils/build_externals.py &> /dev/null
173"${AT_DIR}"/utils/compile_gwt_clients.py -a &> /dev/null
174echo -e "Done!\n"
175
176echo "Populating autotest mysql DB..."
177"${AT_DIR}"/database/migrate.py sync
178"${AT_DIR}"/frontend/manage.py syncdb
179# You may have to run this twice.
180"${AT_DIR}"/frontend/manage.py syncdb
181"${AT_DIR}"/utils/test_importer.py
182echo -e "Done!\n"
183
184echo "Configuring apache to run the autotest web interface..."
185sudo ln -sf "${AT_DIR}"/apache/apache-conf \
186 /etc/apache2/sites-available/autotest-server
187# disable currently active default
188sudo a2dissite default
189# enable autotest server
190sudo a2ensite autotest-server
191# Enable rewrite module
192sudo a2enmod rewrite
193# Setup permissions so that Apache web user can read the proper files.
194chmod -R o+r "${AT_DIR}"
195find "${AT_DIR}"/ -type d | xargs chmod o+x
196chmod o+x "${AT_DIR}"/tko/*.cgi
197# restart server
198sudo /etc/init.d/apache2 restart
199
200echo "Browse to http://localhost to see if Autotest is working."
201echo "For further necessary set up steps, see https://sites.google.com/a/chromium.org/dev/chromium-os/testing/autotest-developer-faq/setup-autotest-server?pli=1"